//-< CTDEP.CPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
// Machine adjustment                                                 * GARRET *
//--------------------------------------------------------------------*--------*

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stdtp.hpp"
#include "numlb.hpp"
#include "l2lst.hpp"
#include "memmv.hpp"
#include "ermsg.hpp"
#include "ctalk.hpp"
#include "ctarr.hpp"
#include "ctcls.hpp"
#undef local
#define local
local Ctk_Object* V_Prim_0 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(...))Prim->Func) ();
   return Sp;
}

local Ctk_Object* V_Prim_1 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(...))Prim->Func) ( *Sp++ );
   return Sp;
}

local Ctk_Object* V_Prim_2 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(...))Prim->Func) ( *Sp, *(Sp+1) );
   return Sp + 2;
}

local Ctk_Object* V_Prim_3 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(...))Prim->Func) ( *Sp, *(Sp+1), *(Sp+2) );
   return Sp + 3;
}

local Ctk_Object* V_Prim_4 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(...))Prim->Func) ( *Sp, *(Sp+1), *(Sp+2), *(Sp+3) );
   return Sp + 4;
}

local Ctk_Object* O_Prim_0 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *--Sp = (*(Ctk_Object(*)(...))Prim->Func)();
   return Sp;
}

local Ctk_Object* O_Prim_1 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *Sp = (*(Ctk_Object(*)(...))Prim->Func)(*Sp);
   return Sp;
}

local Ctk_Object* O_Prim_2 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(Sp+1) = (*(Ctk_Object(*)(...))Prim->Func)( *Sp, *(Sp+1) );
   return Sp + 1;
}

local Ctk_Object* O_Prim_3 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(Sp+2) = (*(Ctk_Object(*)(...))Prim->Func)( *Sp, *(Sp+1), *(Sp+2) );
   return Sp + 2;
}

local Ctk_Object* O_Prim_4 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(Sp+3) = (*(Ctk_Object(*)(...))Prim->Func)( *Sp, *(Sp+1), *(Sp+2), *(Sp+3));
   return Sp + 3;
}

local Ctk_Object* F_Prim_0 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *--(real*)Sp = (*(real(*)(...))Prim->Func)();
   return Sp;
}

local Ctk_Object* F_Prim_1 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   real Res = (*(real(*)(...))Prim->Func)( *Sp++ );
   *--(real*)Sp = Res;
   return Sp;
}

local Ctk_Object* F_Prim_2 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(real*)Sp = (*(real(*)(...))Prim->Func)( *Sp, *(Sp+1) );
   return Sp;
}

local Ctk_Object* F_Prim_3 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(real*)(Sp+1) = (*(real(*)(...))Prim->Func)( *Sp, *(Sp+1), *(Sp+2) );
   return Sp + 1;
}

local Ctk_Object* F_Prim_4 ( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   *(real*)(Sp+2) = (*(real(*)(...))Prim->Func)(*Sp,*(Sp+1),*(Sp+2),*(Sp+3));
   return Sp + 2;
}

local const Ctk_Trampoline V_Prim [] =
  { V_Prim_0, V_Prim_1, V_Prim_2, V_Prim_3, V_Prim_4 };

local const Ctk_Trampoline O_Prim [] =
  { O_Prim_0, O_Prim_1, O_Prim_2, O_Prim_3, O_Prim_4 };

local const Ctk_Trampoline F_Prim [] =
  { F_Prim_0, F_Prim_1, F_Prim_2, F_Prim_3, F_Prim_4 };

global Ctk_Object* Other_Prim ( Ctk_Prim* Prim, Ctk_Object* Sp )  {
   short Size = Prim->Params;
   if( Prim->Result >= 4 ) {
       Ctk_Object* Frame = (Ctk_Object*)alloca ( (Size+1)*4 );
       Ctk_Object* Dst = Frame;
       while( -- Size >= 0 ) *Dst++ = *Sp++;
       *Dst++ = Ctk_Object((char*)Sp -= Prim->Result);
       (*(void(*)(...))Prim->Func)();
   } else {
       Ctk_Object* Frame = (Ctk_Object*)alloca ( Size*4 );
       Ctk_Object* Dst = Frame;
       do *Dst++ = *Sp++; while ( -- Size > 0 );
       switch ( Prim->Result ) {
           case Ctk_Prim::Void:
               (*(void(*)(...))Prim->Func)();
               break;
           case Ctk_Prim::Real:
               *--(real*)Sp = (*(real(*)(...))Prim->Func)();
               break;
           default:
               *--Sp = (*(Ctk_Object(*)(...))Prim->Func)();
       }
   }
   return Sp;
}

global Ctk_Trampoline Ctk_Prim::Caller ( void ) {
   if ( Params < items( V_Prim ) && Result < 4 ) {
      switch ( Result ) {
         case Void: return V_Prim [ Params ];
         case Real: return F_Prim [ Params ];
         default: return O_Prim [ Params ];
      }
   } else return Other_Prim;
}


