#include "ctmdp.hpp"

#ifdef ASM_CTK_MARK

.globl _Ctk_Mark
        .text
_Ctk_Mark:
        link    a6,             #0
        moveml  d2-d7/a2-a6,    sp@-
        movel   a6@(8),         a4
        movel   a6@(12),        d4
        movel   sp,             d5
        clrl    d3
        movel   #0x30001,       d7
        movel   #0xFC000003,    d6
        movel   _rtm_mem+12,	a3

        movel   _rtm_mem+16,	d2
        addl    d2,             a3

        movel   __14Ctk_Descriptor$Table,a5
        jra     Loop_Entry
L400:
        cmpl    sp,             d5
        jls     LEnd
        movel   sp@+,           d4
        movel   sp@+,           a4

Loop_Entry:
        lsll    #2,             d4
        jle     L402
        addl    a4,             d4
L403:
        movel   a4@+,           a2
        tstl    a2
        jeq     L405
        movew   a2@,            d3
        andw    #0xfffc,        d3
        subl    d3,             a2
        movel   a2@,            d0
        movew   d0,             d3
        orw     d7,             a2@
	clrw	d0
        andl    d7,             d0
        jne     L405

        movel   a5@(d3:l:4),	a0

        movel   a0@(12),        a1
        tstl    a1
        jeq     L410
        addql   #4,             a1
        movel   a1@+,           d1
        lsll    #1,             d1
        addl    a1,             d1
L411:
        movel   a1@+,           d0
        movew   d0,             d3
        swap    d0
        pea     a2@(0,d0:w)
        movel   d3,             sp@-
        cmpl    a1,             d1
        jne     L411
        cmpl    a4,             d4
        jne     L403
        jra     L400
L410:
        addqw   #4,a2
        tstw    a0@(6)
        jlt     L415
        movel   a2@+,           d1
        jeq     L405
        movel   a2,             sp@-
        movel   d1,             sp@-
L405:
        cmpl    a4,             d4
        jne     L403
        jra     L400

L402:
        negl    d4
        addl    a4,             d4
L423:
        cmpl    a4,             d4
        jeq     L400
        movel   a4@+,           a2

        movel   a2,             d0
        subl    a3,             d0
        addl    d2,             d0
        jcc     L423
        andl    d6,             d0
        jne     L423

        movel   a2,             d0
        andw    #0xf000,        d0
        movel   d0,             a1
        movew   a2@,            d3
        andw    #0xfffc,        d3
        subl    d3,             a2
        movel   a2,             d0
        andw    #0xf000,        d0
        cmpl    a1,             d0
        jne     L423
        movel   a1@,            d0
        movel   d0,             a0
        subl    #__14Ctk_Heap_Block$Back,d0
        cmpl    #32767,         d0
        jhi     L423

        cmpl    a0@,            a1
        jne     L423

        movew   a2@,            d0
        andw    #0x8001,        d0
        jne     L423

        moveq   #16,            d0
        addl    a1,             d0
        cmpl    a2,             d0
        jhi     L423
        jeq     L428
        movel   a1@(12),        d1
        cmpl    #512,           d1
        jhi     L423

        movel   a2,             a0
        addl    d1,             a0
        cmpl    a1@(4),         a0
        jhi     L423
        negl    d0
        addl    a2,             d0
        divull  d1,             d1:d0
        tstl    d1
        jne     L423
L428:
        orw     d7,     a2@
        btst    #1,     a2@(1)
        jne     L423

        movew   a2@(2),         d3
        movel   a5@(d3:l:4),    a0

        movel   a0@(12),        a1
        tstl    a1
        jeq     L434
        addql   #4,             a1
        movel   a1@+,           d1
        lsll    #1,             d1
        addl    a1,             d1
L435:
        movel   a1@+,           d0
        movew   d0,             d3
        swap    d0
        pea     a2@(0,d0:w)
        movel   d3,             sp@-
        cmpl    a1,             d1
        jne L435
        jra L423
L434:
        addqw   #4,             a2
        tstw    a0@(6)
        jlt     L439
        movel   a2@+,           d1
        jeq     L423
        movel   a2,             sp@-
        movel   d1,             sp@-
        jra     L423
L415:
        movel   a2,             sp@-
        movel   a2,             d0
        andw    #0xf000,        d0
        movel   d0,             a2
        moveq   #4,             d0
        subl    a2@(12),        d0
        asrl    #2,             d0
        movel   d0,             sp@-
        cmpl    a4,             d4
        jne     L403
        jra     L400
L439:
        movel   a2,             sp@-
        movel   a2,             d0
        andw    #0xf000,        d0
        movel   d0,             a2
        moveq   #4,             d0
        subl    a2@(12),        d0
        asrl    #2,             d0
        movel   d0,             sp@-
        jra     L423
LEnd:
        moveml  sp@+,           d2-d7/a2-a6
        unlk    a6
        rts

#endif

#ifdef ASM_CTK_MARK_REGS
.globl _Ctk_Mark_Regs
_Ctk_Mark_Regs:
        link    a6,             #0
        moveml  d2-d7/a2-a5,    sp@-
        movel   sp,             a0
        moveql  #-10,           d0
        movel   d0,             sp@-
        movel   a0,             sp@-
        jsr     _Ctk_Mark
        unlk    a6
        rts
#endif
