//-< CTDEP.CPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//                                                                    * / [] \ *
// Machine adjustment                                                 * GARRET *
//--------------------------------------------------------------------*--------*

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stdtp.hpp"
#include "numlb.hpp"
#include "l2lst.hpp"
#include "memmv.hpp"
#include "ermsg.hpp"
#include "ctalk.hpp"
#include "ctarr.hpp"
#include "ctcls.hpp"

local Ctk_Object* V_Prim0( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)())Prim->Func)();
   return Sp;
}

local Ctk_Object* V_Prim1( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object))Prim->Func)(Sp[0]);
   return Sp + 1;
}

local Ctk_Object* V_Prim2( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1]);
   return Sp + 2;
}

local Ctk_Object* V_Prim3( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2]);
   return Sp + 3;
}

local Ctk_Object* V_Prim4( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	(Sp[0],Sp[1],Sp[2],Sp[3]);
   return Sp + 4;
}

local Ctk_Object* V_Prim5( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4]);
   return Sp + 5;
}

local Ctk_Object* V_Prim6( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object
      ))Prim->Func)
	(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4],Sp[5]);
   return Sp + 6;
}

local Ctk_Object* V_PrimN( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int n = Prim->Params - 6; 
   Ctk_Object* dst = (Ctk_Object*)alloca( n*sizeof(Ctk_Object) ) - 1; 
   Ctk_Object* src = Sp + n;
   while( -- n >= 0 ) *dst++ = *src++; 
   (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	( Sp[0], Sp[1], Sp[2], Sp[3], Sp[4], Sp[5] );
   return Sp += Prim->Params;
}

local Ctk_Object* I_Prim0( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)())Prim->Func)();
   *--Sp = Ctk_Object(val); 
   return Sp;
}

local Ctk_Object* I_Prim1( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object))Prim->Func)(Sp[0]);
   Sp += 1;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_Prim2( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1]);
   Sp += 2;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_Prim3( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2]);
   Sp += 3;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_Prim4( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)	(Sp[0],Sp[1],Sp[2],Sp[3]);
   Sp += 4;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_Prim5( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4]);
   Sp += 5;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_Prim6( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int val = (*(int(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4],Sp[5]);
   Sp += 6;
   *--(int*)Sp = val;
   return Sp;
}

local Ctk_Object* I_PrimN( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int n = Prim->Params - 6; 
   Ctk_Object* dst = (Ctk_Object*)alloca( n*sizeof(Ctk_Object) ) - 1; 
   Ctk_Object* src = Sp + n;
   while( -- n >= 0 ) *dst++ = *src++; 
   int val = (*(int(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	( Sp[0], Sp[1], Sp[2], Sp[3], Sp[4], Sp[5] );
   Sp += Prim->Params;
   *--(int*)Sp = val;
   return Sp; 
}


local Ctk_Object* O_Prim0( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)())Prim->Func)();
   *--Sp = Ctk_Object(val); 
   return Sp;
}

local Ctk_Object* O_Prim1( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object))Prim->Func)(Sp[0]);
   Sp += 1;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_Prim2( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1]);
   Sp += 2;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_Prim3( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2]);
   Sp += 3;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_Prim4( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)	(Sp[0],Sp[1],Sp[2],Sp[3]);
   Sp += 4;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_Prim5( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4]);
   Sp += 5;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_Prim6( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4],Sp[5]);
   Sp += 6;
   *--Sp = val;
   return Sp;
}

local Ctk_Object* O_PrimN( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int n = Prim->Params - 6; 
   Ctk_Object* dst = (Ctk_Object*)alloca( n*sizeof(Ctk_Object) ) - 1; 
   Ctk_Object* src = Sp + n;
   while( -- n >= 0 ) *dst++ = *src++; 
   Ctk_Object val = (*(Ctk_Object(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	( Sp[0], Sp[1], Sp[2], Sp[3], Sp[4], Sp[5] );
   Sp += Prim->Params;
   *--Sp = val;
   return Sp; 
}


local Ctk_Object* F_Prim0( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)())Prim->Func)();
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim1( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object))Prim->Func)(Sp[0]);
   Sp += 1;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim2( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1]);
   Sp += 2;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim3( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2]);
   Sp += 3;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim4( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)	(Sp[0],Sp[1],Sp[2],Sp[3]);
   Sp += 4;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim5( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4]);
   Sp += 5;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_Prim6( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   double val = (*(double(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)(Sp[0],Sp[1],Sp[2],Sp[3],Sp[4],Sp[5]);
   Sp += 6;
   *--(real*)Sp = val;
   return Sp;
}

local Ctk_Object* F_PrimN( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   int n = Prim->Params - 6; 
   Ctk_Object* dst = (Ctk_Object*)alloca( n*sizeof(Ctk_Object) ) - 1; 
   Ctk_Object* src = Sp + n;
   while( -- n >= 0 ) *dst++ = *src++; 
   double val = (*(double(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object))Prim->Func)
	( Sp[0], Sp[1], Sp[2], Sp[3], Sp[4], Sp[5] );
   Sp += Prim->Params;
   *--(real*)Sp = val;
   return Sp; 
}

local Ctk_Object* Multi_Prim( Ctk_Prim* Prim, Ctk_Object* Sp ) {
   Ctk_Object* Fp = Sp;
   switch( Prim->Params ) {  
       case 0: 
           (*(void(*)(Ctk_Object*))Prim->Func)( Sp -= Prim->Result ); 
	   break; 
       case 1: 
           (*(void(*)(Ctk_Object, Ctk_Object*))Prim->Func)( Fp[0], 
		Sp += 1 - Prim->Result ); 
	   break; 
       case 2: 
           (*(void(*)(Ctk_Object, Ctk_Object, Ctk_Object*))Prim->Func)( Fp[0], Fp[1], 
		Sp += 2 - Prim->Result ); 
	   break; 
       case 3: 
           (*(void(*)(Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object*))Prim->Func)( Fp[0], Fp[1], Fp[2], 
		Sp += 3 - Prim->Result ); 
	   break; 
       case 4: 
           (*(void(*)(Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object*))Prim->Func)( Fp[0], Fp[1], Fp[2], Fp[3],  
		Sp += 4 - Prim->Result ); 
	   break; 
       case 5: 
           (*(void(*)(Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object, Ctk_Object*))Prim->Func)( Fp[0], Fp[1], Fp[2], Fp[3], Fp[4], Sp += 5 - Prim->Result ); 
	   break; 
       default:	
           int n = Prim->Params - 6;
           Ctk_Object* Fp = (Ctk_Object*)alloca((n+1)*sizeof(Ctk_Object))-1; 
           Sp += n;
           while( -- n >= 0 ) *Fp++ = *Sp++; 
           *Fp = Ctk_Object(Sp -= Prim->Result);
           (*(void(*)(Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,Ctk_Object,
             Ctk_Object))Prim->Func)
	       ( Fp[0], Fp[1], Fp[2], Fp[3], Fp[4], Fp[5] ); 
   }
   return Sp;
}

local const Ctk_Trampoline V_Prim [] =
  { V_Prim0, V_Prim1, V_Prim2, V_Prim3, V_Prim4, V_Prim5, V_Prim6 };

local const Ctk_Trampoline I_Prim [] =
  { I_Prim0, I_Prim1, I_Prim2, I_Prim3, I_Prim4, I_Prim5, I_Prim6 };

local const Ctk_Trampoline O_Prim [] =
  { O_Prim0, O_Prim1, O_Prim2, O_Prim3, O_Prim4, O_Prim5, O_Prim6 };

local const Ctk_Trampoline F_Prim [] =
  { F_Prim0, F_Prim1, F_Prim2, F_Prim3, F_Prim4, F_Prim5, F_Prim6 };

global Ctk_Trampoline Ctk_Prim::Caller ( void ) {
    switch ( Result ) {
        case Object: return Params <= 6 ? O_Prim[ Params ] : O_PrimN;
        case Void:   return Params <= 6 ? V_Prim[ Params ] : V_PrimN;
        case Real:   return Params <= 6 ? F_Prim[ Params ] : F_PrimN;
        case Int:    return Params <= 6 ? I_Prim[ Params ] : I_PrimN;
        default: return Multi_Prim;
    }
}
