//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  Interface library
//   Informational models
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctmod.hpp,v $
// $Id: ctmod.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTMOD_HPP__
    #define __CTMOD_HPP__

    struct  Ctk_Ed_Cmd : public Ctk_Header {
        nat4           Tag,    Bas,    Rpt,    Lin;
        int4           Sym;
        Ctk_String*    Str;

        enum {   // Codes for ed_cmd Tag field
            Ins_Chr,    // Insert character <Sym> <Rpt> times from position <Bas>
            Rep_Chr,    // Replace <Rpt> characters after <Bas> with <Chr>
            Del_Chr,    // Delete <Rpt> characters after position <Bas>
            Ins_Lin,    // Insert <Rpt> lines <Str> after line <Lin>
            Del_Lin,    // Delete <Rpt> lines after line <Lin>
            Pos,        // Note position at <Bas> <Lin>
            Undo,       // Undo last operation
            Redo,       // Undo last undo
            SOG,        // Start of complex operation
            EOG,        // End of complex operation
            NOP};       // No operation request
      protected:
        Ctk_Ed_Cmd() : Ctk_Header(0) {}
    };

#endif
