//-< INPUT.CPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Input Processor                            Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Input Processor
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: input.cpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#include "editr.hpp"
#include "lokbd.hpp"

Key_Item    const*      Curr;

int Kbd_Init(){
    Curr = Main_Tbl;
    return low_kbd_init();
}

extern "C" void Edit(int i)
  { Editor::Curr->Process(i); }

void    Proc_Key(){
    int i = low_get(Editor::Curr->V->Win);

    while(Curr->From > i || Curr->To < i)
        Curr += 1;
    if(Curr->Func != NULL)
        Curr->Func(Curr->Arg < 0 ? i : Curr->Arg);
    Curr = Curr->Next;
}

void    Proc_Input()
  { while(1) Proc_Key(); }

void    Kbd_Term(){
    low_kbd_term();
}
