//-< INPUT.HPP >------------------------------------------------------*--------*
// Garret Simple Text Editor                      (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//      Input Processor                            Moscow, RUSSIA     * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Input Processor
// Copyright (C) 1993 Garret.
//
// This file is part of IV - Garret Simple Text Editor
//
// IV is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// IV is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with IV; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: input.hpp,v 1.1.1.1 1995/10/04 20:35:49 abramow Exp $
//

#ifndef __INPUT_HPP__
    #define __INPUT_HPP__

    extern  int     Kbd_Init();         // Initialize keyboard
    extern  void    Proc_Key();         // Process key hit
    extern  void    Proc_Input();       // Process the whole input
    extern  void    Kbd_Term();         // Terminate keyboard

#endif
