#include <stdio.h>
#include <stdlib.h>

#include "mmlib.hpp"

#define MAX_N	2048
void*	arr[MAX_N];

extern "C" int sbrk();

int main() {
    int i, j, k;

    for (i = 0, j = 0, k = MAX_N/2; i < 500000; i ++) {
	arr[j] = malloc(i%MAX_N);
	free(arr[k]);
	j = (j + 1)%MAX_N;
	k = (k + 1)%MAX_N;
    }
    printf("core = %#x\n", sbrk(0));
}
