//-< BMLIB.HPP >------------------------------------------------------*--------*
// Garret Object Class Library                    (c) 1992  GARRET    *     ?  *
//                                                                    *   /\|  *
//  Bit manipulation library                                          *  /  \  *
//                           Created:      17-Mar-92   I.V. Abramow   * / [] \ *
//    Declarations           Last update:  11-Jun-93   E.A. Roganow   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __BMLIB_HPP__
    #define __BMLIB_HPP__

    // Is_Pow_2 functions return true if operand x is power of 2

    inline  bool    Is_Pow_2( tiny x )
        { return ( (x-1)&x ) == 0; }

    inline  bool    Is_Pow_2( nat  x )
        { return ( (x-1)&x ) == 0; }

    inline  bool    Is_Pow_2( large x )
        { return ( (x-1)&x ) == 0; }

    // [BWL]_Bit arrays are table form of 2**n function

    export  const   tiny    B_Bit[ 8  ];
    export  const   nat     W_Bit[ 16 ];
    export  const   large   L_Bit[ 32 ];

    export  const   tiny    Num_Bits[ 256 ];
    export  const   tiny    Rev_Bits[ 256 ];
    export  const   tiny    Right_1 [ 256 ];
    export  const   tiny    Left_1  [ 256 ];

#endif
