#include    <string.h>
#include    "stdtp.hpp"
#include    "memmv.hpp"

//-----------------------------------------------------------------------------
// memswap -- swap two regions of memory
// Params :
//   void* p -- address of 1st region in memory
//   void* q -- address of 2nd region in memory
//   int   n -- size of region
//-----------------------------------------------------------------------------

global  void    memswap( void* p, void* q, int n ){
    char*       p1 = (char*)p;
    char*       q1 = (char*)q;
    char        c;

    while( --n >= 0 )
        { c = *p1; *p1++ = *q1; *q1++ = c; }
}
