#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>

#include "stdtp.hpp"
#include "ermsg.hpp"
#include "ctxsw.hpp"

// If Tsk_Save_Stack() and Tsk_Load_Stack) are working correctly, this program
// prints the numbers 0 to 9.

char *env, *env2;

int i, r = 1;

void inner2() {
    int r, len = Tsk_Stack_Size();
    int a[10000];
    a[0] = 1; a[9999] = 2;

    env2 = malloc (len);
    r = Tsk_Save_Stack (env2);
    Trace(".%d\n", r);
    if( a[0] != 1 || a[9999] != 2 ){
        Trace(
          "There seems to be a problem [2]"
          " with Tsk_Save_Stack or Tsk_Load_Stack.\n" );
        exit( 1 );
    }
    if( r > 0 )
        exit( 0 );
}

int inner() {
    int r, len;

    inner2();
    len = Tsk_Stack_Size();
    env = malloc( len );
    r = Tsk_Save_Stack( env );
    Trace( "%d\n", r+1 );
    return r;
}

main () {
    char foo;

    Tsk_Stack_Base = &foo;
    i = inner();
    if (i == 7)
        Tsk_Load_Stack( env2, 9 );
    Tsk_Load_Stack( env, r++ );
    Trace(
      "There seems to be a problem [1]"
      " with Tsk_Save_Stack or Tsk_Load_Stack.\n" );
    exit( 1 );
}

