/*
 * (C) 1994 Garret
 * Author: I.V. Abramow
 * Program to fix some bugs in GNU C++ when generating dependencies
 */

#include <stdio.h>
#include <string.h>

/* Current version of GCC uses 80 char per line limit, but for some strange
   cases in the future it should be enough */
#define BUF_SIZE	4096

int main(int argc, char** argv) {
    char    b[BUF_SIZE];
    char    *p, *q;
    FILE*   in;
    int     i;

    if (argc < 2) return 1;
    for (i = 1; i < argc; i += 1) {
	if (( in = fopen(argv[i], "r")) != NULL) {
	    while (fgets(b, BUF_SIZE, in) != NULL) {
		if ((p = strchr(b, ':')) != NULL) {
		    *p++ = '\0';
		    if ((q = strchr(b, '.')) != NULL) {
			q += 1; *q++ = 'o'; *q++ = '\0';
		    }
		    fprintf(stdout, "$(TMPD)%s : %s", b, p);
		} else fputs(b, stdout);
	    }
	    fclose(in);
	} else {
	    fprintf(stderr, "%s: Can't open file \"%s\"\n", argv[0], argv[i]);
	}
    }
    return 0;
}
