//-< CHANL.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Virtual active channel realisation                                 *  /  \  *
//                           Created:      15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  24-Oct-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __CHANL_HPP__
 #define __CHANL_HPP__

 class   Dbs_D_File;

 struct  Dbs_Active_File  {
    long        Stamp;
    Dbs_D_File* File;
 };

 class  Dbs_Channel  {
   private:
    Dbs_Active_File * Active_File_Table;
    nat          Active_Files_Number ;
    nat          Active_Files_Limit;
    long         Timer;

   public :
    static Dbs_Channel* Manager;

    large        Scale ( void );
    inline large Tick  ( void ) { return ++Timer > 0 ? Timer : Scale(); }
    int          Activate_File ( Dbs_D_File* File );
    void         Revision ( nat Limit );
    void         Erase ( Dbs_Active_File* Del );

    Dbs_Channel  ( nat Limit );
    ~Dbs_Channel ( void );
 };

#endif
