//-< TFILE.HPP >------------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET    *     ?  *
// ( Garret object oriented data storage )                            *   /\|  *
// Low level file I/O operations                                      *  /  \  *
//                           Created:      15-Feb-92   K.A. Knijnik   * / [] \ *
//                           Last update:  26-Mar-92   K.A. Knijnik   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __TFILE_HPP__
 #define __TFILE_HPP__

 #include "filio.hpp"

 class Dbs_T_File : public Dbs_File {
   protected:
    char*   Buf;
    large   Buf_Size;
    static const  int Buf_Quant = 1024;
    void    Realloc( large Size )
      { Buf = (char*)realloc( Buf, Buf_Size = ALIGN( Size, Buf_Quant ) ); }

   public:
    int     Open  ( int Flags, int Mode=0666) ;
    void    Sync  ( void ) ;
    int     Close ( void ) ;
    int     Unlink( void ) ;
    int     Access( int Mode = 0 ) ;
    int     Read  ( void* Buffer, unsigned Quant ) ;
    int     Write ( void* Buffer, unsigned Quant ) ;
    large   Seek  ( long  Offset, int Whence=0   ) ;
    int     ChSize( long  Length );
 };

#endif
