//-< CTPAC.HPP >------------------------------------------------------*--------*
// C-Talk                   Version 1.0           (c) 1993  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//  C-Talk package                                                    * / [] \ *
//                                                                    * GARRET *
//--------------------------------------------------------------------*--------*
// Edit history:
//                          Last update:

#ifndef __CTPAC_HPP__
 #define __CTPAC_HPP__

 struct Ctk_Body : Ctk_Header {
     int4          Offs;     // offset in file
     int4          Len;      // length of body ( if 0 then it has been modified
     Ctk_String*   New_Text; // and new text is in New_Text string
     int4          Size() { return New_Text ? New_Text->N_Elems - 1 : Len; }
 };

 class Ctk_Package : Ctk_Class {
   private:
     enum { User, System, Modified };
     int4          Stat;      // if package is system it cann't be modified

     Ctk_Vector_O* With;      // result of header compilation
     Ctk_Vector_O* Use;       // ...
     Ctk_Proc*     Init;      // initialize function for package
   public:
     void          Save ();
     static Ctk_Package* New ( nat2 File );
     CTK_CONSTRUCTOR( Ctk_Package, 0 );
 };

#endif
