#include "stdtp.hpp"
#include "ermsg.hpp"
#include "numlb.hpp"
#include "ctalk.hpp"
#include "ctstr.hpp"
#include <curses.h>

struct Window : Ctk_Header {
   WINDOW*    Win;
   void       Flush();
   void       Puts( int4 x, int4 y, Ctk_String* Str );
   void       Putc( int4 x, int4 y, int4 Sym );
   void       Clear();
   void       Close();
   void       Move( int4 x, int4 y );
   Window*    New( int4 x_bas, int4 y_bas, int4 x_len, int4 y_len );
   static     void  Initialize();
  private:
   Window() : Ctk_Header( Ctk_Header_Desc, No_Ptr ){}
};

