//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  Interface library
//   Informational models
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/edi/ctsto.hpp,v $
// $Id: ctsto.hpp,v 1.1.1.1 1995/10/04 20:35:43 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTSTO_HPP__
    #define __CTSTO_HPP__

    #include <fcntl.h>

    #include "stdtp.hpp"
    #include "ermsg.hpp"
    #include "numlb.hpp"
    #include "ctalk.hpp"
    #include "ctlib.hpp"
    #include "ctcol.hpp"
    #include "ctarr.hpp"
    #include "ctstr.hpp"
    #include "ctios.hpp"

    #define STORAGE( TP  ) \
      struct Line_Storage_##TP : Ctk_Header {                       \
        int4                Top,Bot;                                \
        Ctk_Array_##TP*     Stack;                                  \
        Ctk_String* 	    File_Name;				    \
	Ctk_Object	    Obj;				    \
        Ctk_String* 	    Modified;				    \
                                                                    \
        void                Load ( Ctk_String* File );              \
        void                Save ( Ctk_String* File );              \
        Ctk_Array_I4*       Map  ();                                \
      private:							    \
	Line_Storage_##TP();					    \
     };                                                             \
                                                                    \
     struct Text_Storage_##TP : Ctk_Header {                        \
         Line_Storage_##TP* Store;                                  \
         Ctk_Array_I4*      Stack;                                  \
         int4               Top;                                    \
         int4               Bot;                                    \
         int4               S_Bot;                                  \
                                                                    \
         void               Goto ( int4 Line );                     \
         void               Come ( int4 Offs );                     \
         int4               Scan ( Ctk_Array_##TP* Str, int4 Offs); \
       private:							    \
	 Text_Storage_##TP();					    \
     };

    STORAGE(I1); STORAGE(I2);

#endif
