//-----------------------------------------------------------------------------
// C-Talk programming environment.                     (C) 1993 Garret
//  System Library
//   OS Interface
//    C++ interface
// $Source: /usr/users/cvs-root/mtalk/ctalk/lib/sys/ctosi.hpp,v $
// $Id: ctosi.hpp,v 1.1.1.1 1995/10/04 20:35:44 abramow Exp $
//-----------------------------------------------------------------------------

#ifndef __CTOSI_HPP__
    #define __CTOSI_HPP__

    struct  Ctk_Host_Info : public  Ctk_Header {
        Ctk_String*     sysname;
        Ctk_String*     nodename;
        Ctk_String*     release;
        Ctk_String*     version;
        Ctk_String*     machine;

	Ctk_Host_Info();
    };

    struct  Ctk_User_Info : public  Ctk_Header {
        Ctk_String*     login_name;
        Ctk_String*     real_name;
        Ctk_Pathname*   home_dir;

	Ctk_User_Info();
    };

    struct  Ctk_System_Error : public Ctk_Exception {
        int4    Code;

        Ctk_System_Error(int i);
	static	void	Initialise();
    };

    export  const   char*   Ctk_Sys_Err_Text(int i);
    export  Ctk_String*     Ctk_System_Error_As_String(Ctk_System_Error* e);
    export  int             Ctk_Sys_Spawn(Ctk_String* Cmd);
#endif
