//-----------------------------------------------------------------------------
//   Fifth machine implementation
//   Copyright (C) 1995 Garret
//
// This file is part of Garret C-Talk.
//
// Garret C-Talk is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// Garret C-Talk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Garret C-Talk; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//-----------------------------------------------------------------------------

#include "stdtp.hpp"
#include "numlb.hpp"
#include "ctalk.hpp"
#include "fifth.hpp"

const char*	fifth::insn_mnem[fifth::n_insns] = {
    #define DEF_FIFTH_INSN(MNEM, FMT, ESIZE, FLAGS, CODE) #MNEM,
    #include "fifth.dpp"
};

const char	fifth::bad_insn_mnem[] = { "<BAD>" };

const char	fifth::insn_ext_len[fifth::n_insns] = {
    #define DEF_FIFTH_INSN(MNEM, FMT, ESIZE, FLAGS, CODE) ESIZE,
    #include "fifth.dpp"
};

const char	fifth::insn_format[fifth::n_insns] = {
    #define DEF_FIFTH_INSN(MNEM, FMT, ESIZE, FLAGS, CODE) FMT,
    #include "fifth.dpp"
};

