//-< TREES.HPP >------------------------------------------------------*--------*
// Garret Object Class Library                    (c) 1992  GARRET    *     ?  *
//                                                                    *   /\|  *
//                                                                    *  /  \  *
//  Trees                    Created:      13-feb-92   I.V. Abramow   * / [] \ *
//    Declarations           Last update:  13-feb-92   I.V. Abramow   * GARRET *
//--------------------------------------------------------------------*--------*

#ifndef __TREES_HPP__
    #define __TREES_HPP__

    // Warning : The Fields T_Brother and T_Sibling assumed to be correct
    struct  Tre_Node {
        Tre_Node*       T_Father;
        Tre_Node*       T_Brother;
        Tre_Node*       T_Sibling;

        void            Link_To( Tre_Node* Father );
        void            Link_After( Tre_Node* Brother );
        void            Unlink( void );
        void            Insert( Tre_Node* Father );
        void            Remove( void );
        bool            Have( Tre_Node* Node );

        #if DEBUG >= DUMP
            void        Dump( int i = 0 );
        #endif
    };

#endif
