#include    <string.h>

#include    "stdtp.hpp"
#include    "ermsg.hpp"
#include    "dnmem.hpp"
#include    "strng.hpp"

global  String* proc    Str_Cat( String* p, String* q ){
    String* r = p;

    while( r->Next != NULL )
        r = r->Next;
    r->Next = q;
    return p;
}

global  String* proc    New_String( char* p ){
    int     i;
    String* s = Str_New( i =  strlen( p ) );

    strcpy( s->Str, p );
    s->Length = i + 1;
    s->Next = NULL;
    return s;
}

global  String* proc String::operator+( String& p ){
    register    int     l = this->Length + p.Length;
    register    String* q = Str_New( l );

    if( l < 0 ) Fatal( "String constant too long" );
    memcpy( q->Str, this->Str, this->Length );
    memcpy( &( q->Str[ this->Length ] ), p.Str, p.Length );
    q->Length = l;
    q->Str[ l ] = 0;
    return q;
}

global  String* String::Dup( void ){
    register    String* q;
    String*     r = this;

    q = Str_New( Length ); memcpy( q, r, sizeof( String ) - 1 + r->Length );
    for( String* p = q; r->Next != NULL; r = r->Next ){
        q = q->Next = Str_New( r->Next->Length );
        q->Length = r->Next->Length;
        memcpy( q->Str, r->Next, r->Next->Length );
    }
    q->Next = NULL;
    return  p;
}

global  bool    proc String::operator==( String& p ){
    return  this->Length == p.Length
      && memcmp( this->Str, p.Str, this->Length ) == 0;
}

global  String* proc Str_Table::Push( nat Size, char* p ){

    for( String* s = Chain; s != NULL; s = s->Next ){
        if( s->Length == Size && memcmp( s->Str, p, Size ) == 0 )
            return  s;
    }
    s = Str_Stack::Push( Size, p );
    s->Next = Chain;
    return Chain = s;
}
