#include    <stdio.h>
#include    <iostream.h>
#include    "stdtp.hpp"
#include    "ermsg.hpp"
#include    "dnmem.hpp"
#include    "l2lst.hpp"
#include    "semph.hpp"

// Hlestakow's test
#define SEM_NUM 3001

Semaphore   *sa[SEM_NUM];
int         dat[SEM_NUM];

int   transl(int num, char**){
    while (TRUE) {
        sa[num]->wait();
        dat[num + 1] = dat[num];
        sa[num + 1]->signal();
    }
}

int   loop(int prm, char**){
    while(--prm >= 0){
        dat[0] = prm;
        Trace("kO %d\n", prm);
        sa[0]->signal();
        sa[SEM_NUM-1]->wait();
        Trace("Ok %d\n", dat[SEM_NUM - 1]);
    }
    return 0;
}

int null_proc(int, char**){
    while(TRUE)
      { pause(); Task::reschedule(); }
}

int main1(){
    Task* t;
    Semaphore* s;

    s = new Semaphore;
    Task::run(null_proc, 0, NULL, FALSE, 0);
    if ((t = Task::fork()) == NULL) {
        Trace( " **** qq\n" );
        for (int i = 0; i < 10; i++) {
            Trace("waiting\n");
            s->wait();
            Trace("received\n");
        }
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::sleep(1);
        Trace("***********************************************************\n");
        Task::exit();
    } else {
        Task::reschedule();
        for (int i = 0; i < 10; i++){
            Trace("sending\n");
            s->signal();
            Trace("sended\n");
        }
    }
    Trace(" + + + + + + \n");
    for (int i = 0; i < SEM_NUM; i++)
        sa[i] = new Semaphore;
    Trace(" + + + + + + \n");
    for (i = 0; i < (SEM_NUM - 1); i++)
        Task::run(transl, i, NULL, FALSE);
    Trace(" + + + + + + \n");
    Task::run(loop, 10);
    Task::reschedule();
    Task::sleep(10);
    Trace(" + + + + + + \n");
    Trace( "OOOOO\n" );
}

int main(){
    Task::init();
    main1();
    return 0;
}
